// +build !ignore_autogenerated

// Copyright 2021 Antrea Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by conversion-gen. DO NOT EDIT.

package v1beta2

import (
	unsafe "unsafe"

	controlplane "github.com/vmware-tanzu/antrea/pkg/apis/controlplane"
	v1alpha1 "github.com/vmware-tanzu/antrea/pkg/apis/security/v1alpha1"
	conversion "k8s.io/apimachinery/pkg/conversion"
	runtime "k8s.io/apimachinery/pkg/runtime"
	types "k8s.io/apimachinery/pkg/types"
	intstr "k8s.io/apimachinery/pkg/util/intstr"
)

func init() {
	localSchemeBuilder.Register(RegisterConversions)
}

// RegisterConversions adds conversion functions to the given scheme.
// Public to allow building arbitrary schemes.
func RegisterConversions(s *runtime.Scheme) error {
	if err := s.AddGeneratedConversionFunc((*AddressGroup)(nil), (*controlplane.AddressGroup)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_AddressGroup_To_controlplane_AddressGroup(a.(*AddressGroup), b.(*controlplane.AddressGroup), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.AddressGroup)(nil), (*AddressGroup)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_AddressGroup_To_v1beta2_AddressGroup(a.(*controlplane.AddressGroup), b.(*AddressGroup), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*AddressGroupList)(nil), (*controlplane.AddressGroupList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_AddressGroupList_To_controlplane_AddressGroupList(a.(*AddressGroupList), b.(*controlplane.AddressGroupList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.AddressGroupList)(nil), (*AddressGroupList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_AddressGroupList_To_v1beta2_AddressGroupList(a.(*controlplane.AddressGroupList), b.(*AddressGroupList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*AddressGroupPatch)(nil), (*controlplane.AddressGroupPatch)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_AddressGroupPatch_To_controlplane_AddressGroupPatch(a.(*AddressGroupPatch), b.(*controlplane.AddressGroupPatch), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.AddressGroupPatch)(nil), (*AddressGroupPatch)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_AddressGroupPatch_To_v1beta2_AddressGroupPatch(a.(*controlplane.AddressGroupPatch), b.(*AddressGroupPatch), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*AppliedToGroup)(nil), (*controlplane.AppliedToGroup)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_AppliedToGroup_To_controlplane_AppliedToGroup(a.(*AppliedToGroup), b.(*controlplane.AppliedToGroup), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.AppliedToGroup)(nil), (*AppliedToGroup)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_AppliedToGroup_To_v1beta2_AppliedToGroup(a.(*controlplane.AppliedToGroup), b.(*AppliedToGroup), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*AppliedToGroupList)(nil), (*controlplane.AppliedToGroupList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_AppliedToGroupList_To_controlplane_AppliedToGroupList(a.(*AppliedToGroupList), b.(*controlplane.AppliedToGroupList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.AppliedToGroupList)(nil), (*AppliedToGroupList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_AppliedToGroupList_To_v1beta2_AppliedToGroupList(a.(*controlplane.AppliedToGroupList), b.(*AppliedToGroupList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*AppliedToGroupPatch)(nil), (*controlplane.AppliedToGroupPatch)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_AppliedToGroupPatch_To_controlplane_AppliedToGroupPatch(a.(*AppliedToGroupPatch), b.(*controlplane.AppliedToGroupPatch), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.AppliedToGroupPatch)(nil), (*AppliedToGroupPatch)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_AppliedToGroupPatch_To_v1beta2_AppliedToGroupPatch(a.(*controlplane.AppliedToGroupPatch), b.(*AppliedToGroupPatch), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ClusterGroupMembers)(nil), (*controlplane.ClusterGroupMembers)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ClusterGroupMembers_To_controlplane_ClusterGroupMembers(a.(*ClusterGroupMembers), b.(*controlplane.ClusterGroupMembers), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.ClusterGroupMembers)(nil), (*ClusterGroupMembers)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_ClusterGroupMembers_To_v1beta2_ClusterGroupMembers(a.(*controlplane.ClusterGroupMembers), b.(*ClusterGroupMembers), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ExternalEntityReference)(nil), (*controlplane.ExternalEntityReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ExternalEntityReference_To_controlplane_ExternalEntityReference(a.(*ExternalEntityReference), b.(*controlplane.ExternalEntityReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.ExternalEntityReference)(nil), (*ExternalEntityReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_ExternalEntityReference_To_v1beta2_ExternalEntityReference(a.(*controlplane.ExternalEntityReference), b.(*ExternalEntityReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*GroupAssociation)(nil), (*controlplane.GroupAssociation)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_GroupAssociation_To_controlplane_GroupAssociation(a.(*GroupAssociation), b.(*controlplane.GroupAssociation), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.GroupAssociation)(nil), (*GroupAssociation)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_GroupAssociation_To_v1beta2_GroupAssociation(a.(*controlplane.GroupAssociation), b.(*GroupAssociation), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*GroupMember)(nil), (*controlplane.GroupMember)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_GroupMember_To_controlplane_GroupMember(a.(*GroupMember), b.(*controlplane.GroupMember), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.GroupMember)(nil), (*GroupMember)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_GroupMember_To_v1beta2_GroupMember(a.(*controlplane.GroupMember), b.(*GroupMember), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*GroupReference)(nil), (*controlplane.GroupReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_GroupReference_To_controlplane_GroupReference(a.(*GroupReference), b.(*controlplane.GroupReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.GroupReference)(nil), (*GroupReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_GroupReference_To_v1beta2_GroupReference(a.(*controlplane.GroupReference), b.(*GroupReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*IPBlock)(nil), (*controlplane.IPBlock)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_IPBlock_To_controlplane_IPBlock(a.(*IPBlock), b.(*controlplane.IPBlock), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.IPBlock)(nil), (*IPBlock)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_IPBlock_To_v1beta2_IPBlock(a.(*controlplane.IPBlock), b.(*IPBlock), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*IPNet)(nil), (*controlplane.IPNet)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_IPNet_To_controlplane_IPNet(a.(*IPNet), b.(*controlplane.IPNet), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.IPNet)(nil), (*IPNet)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_IPNet_To_v1beta2_IPNet(a.(*controlplane.IPNet), b.(*IPNet), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NamedPort)(nil), (*controlplane.NamedPort)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NamedPort_To_controlplane_NamedPort(a.(*NamedPort), b.(*controlplane.NamedPort), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.NamedPort)(nil), (*NamedPort)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_NamedPort_To_v1beta2_NamedPort(a.(*controlplane.NamedPort), b.(*NamedPort), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NetworkPolicy)(nil), (*controlplane.NetworkPolicy)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NetworkPolicy_To_controlplane_NetworkPolicy(a.(*NetworkPolicy), b.(*controlplane.NetworkPolicy), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.NetworkPolicy)(nil), (*NetworkPolicy)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_NetworkPolicy_To_v1beta2_NetworkPolicy(a.(*controlplane.NetworkPolicy), b.(*NetworkPolicy), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NetworkPolicyList)(nil), (*controlplane.NetworkPolicyList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NetworkPolicyList_To_controlplane_NetworkPolicyList(a.(*NetworkPolicyList), b.(*controlplane.NetworkPolicyList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.NetworkPolicyList)(nil), (*NetworkPolicyList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_NetworkPolicyList_To_v1beta2_NetworkPolicyList(a.(*controlplane.NetworkPolicyList), b.(*NetworkPolicyList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NetworkPolicyNodeStatus)(nil), (*controlplane.NetworkPolicyNodeStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NetworkPolicyNodeStatus_To_controlplane_NetworkPolicyNodeStatus(a.(*NetworkPolicyNodeStatus), b.(*controlplane.NetworkPolicyNodeStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.NetworkPolicyNodeStatus)(nil), (*NetworkPolicyNodeStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_NetworkPolicyNodeStatus_To_v1beta2_NetworkPolicyNodeStatus(a.(*controlplane.NetworkPolicyNodeStatus), b.(*NetworkPolicyNodeStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NetworkPolicyPeer)(nil), (*controlplane.NetworkPolicyPeer)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NetworkPolicyPeer_To_controlplane_NetworkPolicyPeer(a.(*NetworkPolicyPeer), b.(*controlplane.NetworkPolicyPeer), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.NetworkPolicyPeer)(nil), (*NetworkPolicyPeer)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_NetworkPolicyPeer_To_v1beta2_NetworkPolicyPeer(a.(*controlplane.NetworkPolicyPeer), b.(*NetworkPolicyPeer), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NetworkPolicyReference)(nil), (*controlplane.NetworkPolicyReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NetworkPolicyReference_To_controlplane_NetworkPolicyReference(a.(*NetworkPolicyReference), b.(*controlplane.NetworkPolicyReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.NetworkPolicyReference)(nil), (*NetworkPolicyReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_NetworkPolicyReference_To_v1beta2_NetworkPolicyReference(a.(*controlplane.NetworkPolicyReference), b.(*NetworkPolicyReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NetworkPolicyRule)(nil), (*controlplane.NetworkPolicyRule)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NetworkPolicyRule_To_controlplane_NetworkPolicyRule(a.(*NetworkPolicyRule), b.(*controlplane.NetworkPolicyRule), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.NetworkPolicyRule)(nil), (*NetworkPolicyRule)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_NetworkPolicyRule_To_v1beta2_NetworkPolicyRule(a.(*controlplane.NetworkPolicyRule), b.(*NetworkPolicyRule), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NetworkPolicyStats)(nil), (*controlplane.NetworkPolicyStats)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NetworkPolicyStats_To_controlplane_NetworkPolicyStats(a.(*NetworkPolicyStats), b.(*controlplane.NetworkPolicyStats), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.NetworkPolicyStats)(nil), (*NetworkPolicyStats)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_NetworkPolicyStats_To_v1beta2_NetworkPolicyStats(a.(*controlplane.NetworkPolicyStats), b.(*NetworkPolicyStats), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NetworkPolicyStatus)(nil), (*controlplane.NetworkPolicyStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NetworkPolicyStatus_To_controlplane_NetworkPolicyStatus(a.(*NetworkPolicyStatus), b.(*controlplane.NetworkPolicyStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.NetworkPolicyStatus)(nil), (*NetworkPolicyStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_NetworkPolicyStatus_To_v1beta2_NetworkPolicyStatus(a.(*controlplane.NetworkPolicyStatus), b.(*NetworkPolicyStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*NodeStatsSummary)(nil), (*controlplane.NodeStatsSummary)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NodeStatsSummary_To_controlplane_NodeStatsSummary(a.(*NodeStatsSummary), b.(*controlplane.NodeStatsSummary), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.NodeStatsSummary)(nil), (*NodeStatsSummary)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_NodeStatsSummary_To_v1beta2_NodeStatsSummary(a.(*controlplane.NodeStatsSummary), b.(*NodeStatsSummary), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*PodReference)(nil), (*controlplane.PodReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_PodReference_To_controlplane_PodReference(a.(*PodReference), b.(*controlplane.PodReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.PodReference)(nil), (*PodReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_PodReference_To_v1beta2_PodReference(a.(*controlplane.PodReference), b.(*PodReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*Service)(nil), (*controlplane.Service)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_Service_To_controlplane_Service(a.(*Service), b.(*controlplane.Service), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.Service)(nil), (*Service)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_Service_To_v1beta2_Service(a.(*controlplane.Service), b.(*Service), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ServiceReference)(nil), (*controlplane.ServiceReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ServiceReference_To_controlplane_ServiceReference(a.(*ServiceReference), b.(*controlplane.ServiceReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*controlplane.ServiceReference)(nil), (*ServiceReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_controlplane_ServiceReference_To_v1beta2_ServiceReference(a.(*controlplane.ServiceReference), b.(*ServiceReference), scope)
	}); err != nil {
		return err
	}
	return nil
}

func autoConvert_v1beta2_AddressGroup_To_controlplane_AddressGroup(in *AddressGroup, out *controlplane.AddressGroup, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.GroupMembers = *(*[]controlplane.GroupMember)(unsafe.Pointer(&in.GroupMembers))
	return nil
}

// Convert_v1beta2_AddressGroup_To_controlplane_AddressGroup is an autogenerated conversion function.
func Convert_v1beta2_AddressGroup_To_controlplane_AddressGroup(in *AddressGroup, out *controlplane.AddressGroup, s conversion.Scope) error {
	return autoConvert_v1beta2_AddressGroup_To_controlplane_AddressGroup(in, out, s)
}

func autoConvert_controlplane_AddressGroup_To_v1beta2_AddressGroup(in *controlplane.AddressGroup, out *AddressGroup, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.GroupMembers = *(*[]GroupMember)(unsafe.Pointer(&in.GroupMembers))
	return nil
}

// Convert_controlplane_AddressGroup_To_v1beta2_AddressGroup is an autogenerated conversion function.
func Convert_controlplane_AddressGroup_To_v1beta2_AddressGroup(in *controlplane.AddressGroup, out *AddressGroup, s conversion.Scope) error {
	return autoConvert_controlplane_AddressGroup_To_v1beta2_AddressGroup(in, out, s)
}

func autoConvert_v1beta2_AddressGroupList_To_controlplane_AddressGroupList(in *AddressGroupList, out *controlplane.AddressGroupList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]controlplane.AddressGroup)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1beta2_AddressGroupList_To_controlplane_AddressGroupList is an autogenerated conversion function.
func Convert_v1beta2_AddressGroupList_To_controlplane_AddressGroupList(in *AddressGroupList, out *controlplane.AddressGroupList, s conversion.Scope) error {
	return autoConvert_v1beta2_AddressGroupList_To_controlplane_AddressGroupList(in, out, s)
}

func autoConvert_controlplane_AddressGroupList_To_v1beta2_AddressGroupList(in *controlplane.AddressGroupList, out *AddressGroupList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]AddressGroup)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_controlplane_AddressGroupList_To_v1beta2_AddressGroupList is an autogenerated conversion function.
func Convert_controlplane_AddressGroupList_To_v1beta2_AddressGroupList(in *controlplane.AddressGroupList, out *AddressGroupList, s conversion.Scope) error {
	return autoConvert_controlplane_AddressGroupList_To_v1beta2_AddressGroupList(in, out, s)
}

func autoConvert_v1beta2_AddressGroupPatch_To_controlplane_AddressGroupPatch(in *AddressGroupPatch, out *controlplane.AddressGroupPatch, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.AddedGroupMembers = *(*[]controlplane.GroupMember)(unsafe.Pointer(&in.AddedGroupMembers))
	out.RemovedGroupMembers = *(*[]controlplane.GroupMember)(unsafe.Pointer(&in.RemovedGroupMembers))
	return nil
}

// Convert_v1beta2_AddressGroupPatch_To_controlplane_AddressGroupPatch is an autogenerated conversion function.
func Convert_v1beta2_AddressGroupPatch_To_controlplane_AddressGroupPatch(in *AddressGroupPatch, out *controlplane.AddressGroupPatch, s conversion.Scope) error {
	return autoConvert_v1beta2_AddressGroupPatch_To_controlplane_AddressGroupPatch(in, out, s)
}

func autoConvert_controlplane_AddressGroupPatch_To_v1beta2_AddressGroupPatch(in *controlplane.AddressGroupPatch, out *AddressGroupPatch, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.AddedGroupMembers = *(*[]GroupMember)(unsafe.Pointer(&in.AddedGroupMembers))
	out.RemovedGroupMembers = *(*[]GroupMember)(unsafe.Pointer(&in.RemovedGroupMembers))
	return nil
}

// Convert_controlplane_AddressGroupPatch_To_v1beta2_AddressGroupPatch is an autogenerated conversion function.
func Convert_controlplane_AddressGroupPatch_To_v1beta2_AddressGroupPatch(in *controlplane.AddressGroupPatch, out *AddressGroupPatch, s conversion.Scope) error {
	return autoConvert_controlplane_AddressGroupPatch_To_v1beta2_AddressGroupPatch(in, out, s)
}

func autoConvert_v1beta2_AppliedToGroup_To_controlplane_AppliedToGroup(in *AppliedToGroup, out *controlplane.AppliedToGroup, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.GroupMembers = *(*[]controlplane.GroupMember)(unsafe.Pointer(&in.GroupMembers))
	return nil
}

// Convert_v1beta2_AppliedToGroup_To_controlplane_AppliedToGroup is an autogenerated conversion function.
func Convert_v1beta2_AppliedToGroup_To_controlplane_AppliedToGroup(in *AppliedToGroup, out *controlplane.AppliedToGroup, s conversion.Scope) error {
	return autoConvert_v1beta2_AppliedToGroup_To_controlplane_AppliedToGroup(in, out, s)
}

func autoConvert_controlplane_AppliedToGroup_To_v1beta2_AppliedToGroup(in *controlplane.AppliedToGroup, out *AppliedToGroup, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.GroupMembers = *(*[]GroupMember)(unsafe.Pointer(&in.GroupMembers))
	return nil
}

// Convert_controlplane_AppliedToGroup_To_v1beta2_AppliedToGroup is an autogenerated conversion function.
func Convert_controlplane_AppliedToGroup_To_v1beta2_AppliedToGroup(in *controlplane.AppliedToGroup, out *AppliedToGroup, s conversion.Scope) error {
	return autoConvert_controlplane_AppliedToGroup_To_v1beta2_AppliedToGroup(in, out, s)
}

func autoConvert_v1beta2_AppliedToGroupList_To_controlplane_AppliedToGroupList(in *AppliedToGroupList, out *controlplane.AppliedToGroupList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]controlplane.AppliedToGroup)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1beta2_AppliedToGroupList_To_controlplane_AppliedToGroupList is an autogenerated conversion function.
func Convert_v1beta2_AppliedToGroupList_To_controlplane_AppliedToGroupList(in *AppliedToGroupList, out *controlplane.AppliedToGroupList, s conversion.Scope) error {
	return autoConvert_v1beta2_AppliedToGroupList_To_controlplane_AppliedToGroupList(in, out, s)
}

func autoConvert_controlplane_AppliedToGroupList_To_v1beta2_AppliedToGroupList(in *controlplane.AppliedToGroupList, out *AppliedToGroupList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]AppliedToGroup)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_controlplane_AppliedToGroupList_To_v1beta2_AppliedToGroupList is an autogenerated conversion function.
func Convert_controlplane_AppliedToGroupList_To_v1beta2_AppliedToGroupList(in *controlplane.AppliedToGroupList, out *AppliedToGroupList, s conversion.Scope) error {
	return autoConvert_controlplane_AppliedToGroupList_To_v1beta2_AppliedToGroupList(in, out, s)
}

func autoConvert_v1beta2_AppliedToGroupPatch_To_controlplane_AppliedToGroupPatch(in *AppliedToGroupPatch, out *controlplane.AppliedToGroupPatch, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.AddedGroupMembers = *(*[]controlplane.GroupMember)(unsafe.Pointer(&in.AddedGroupMembers))
	out.RemovedGroupMembers = *(*[]controlplane.GroupMember)(unsafe.Pointer(&in.RemovedGroupMembers))
	return nil
}

// Convert_v1beta2_AppliedToGroupPatch_To_controlplane_AppliedToGroupPatch is an autogenerated conversion function.
func Convert_v1beta2_AppliedToGroupPatch_To_controlplane_AppliedToGroupPatch(in *AppliedToGroupPatch, out *controlplane.AppliedToGroupPatch, s conversion.Scope) error {
	return autoConvert_v1beta2_AppliedToGroupPatch_To_controlplane_AppliedToGroupPatch(in, out, s)
}

func autoConvert_controlplane_AppliedToGroupPatch_To_v1beta2_AppliedToGroupPatch(in *controlplane.AppliedToGroupPatch, out *AppliedToGroupPatch, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.AddedGroupMembers = *(*[]GroupMember)(unsafe.Pointer(&in.AddedGroupMembers))
	out.RemovedGroupMembers = *(*[]GroupMember)(unsafe.Pointer(&in.RemovedGroupMembers))
	return nil
}

// Convert_controlplane_AppliedToGroupPatch_To_v1beta2_AppliedToGroupPatch is an autogenerated conversion function.
func Convert_controlplane_AppliedToGroupPatch_To_v1beta2_AppliedToGroupPatch(in *controlplane.AppliedToGroupPatch, out *AppliedToGroupPatch, s conversion.Scope) error {
	return autoConvert_controlplane_AppliedToGroupPatch_To_v1beta2_AppliedToGroupPatch(in, out, s)
}

func autoConvert_v1beta2_ClusterGroupMembers_To_controlplane_ClusterGroupMembers(in *ClusterGroupMembers, out *controlplane.ClusterGroupMembers, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.EffectiveMembers = *(*[]controlplane.GroupMember)(unsafe.Pointer(&in.EffectiveMembers))
	return nil
}

// Convert_v1beta2_ClusterGroupMembers_To_controlplane_ClusterGroupMembers is an autogenerated conversion function.
func Convert_v1beta2_ClusterGroupMembers_To_controlplane_ClusterGroupMembers(in *ClusterGroupMembers, out *controlplane.ClusterGroupMembers, s conversion.Scope) error {
	return autoConvert_v1beta2_ClusterGroupMembers_To_controlplane_ClusterGroupMembers(in, out, s)
}

func autoConvert_controlplane_ClusterGroupMembers_To_v1beta2_ClusterGroupMembers(in *controlplane.ClusterGroupMembers, out *ClusterGroupMembers, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.EffectiveMembers = *(*[]GroupMember)(unsafe.Pointer(&in.EffectiveMembers))
	return nil
}

// Convert_controlplane_ClusterGroupMembers_To_v1beta2_ClusterGroupMembers is an autogenerated conversion function.
func Convert_controlplane_ClusterGroupMembers_To_v1beta2_ClusterGroupMembers(in *controlplane.ClusterGroupMembers, out *ClusterGroupMembers, s conversion.Scope) error {
	return autoConvert_controlplane_ClusterGroupMembers_To_v1beta2_ClusterGroupMembers(in, out, s)
}

func autoConvert_v1beta2_ExternalEntityReference_To_controlplane_ExternalEntityReference(in *ExternalEntityReference, out *controlplane.ExternalEntityReference, s conversion.Scope) error {
	out.Name = in.Name
	out.Namespace = in.Namespace
	return nil
}

// Convert_v1beta2_ExternalEntityReference_To_controlplane_ExternalEntityReference is an autogenerated conversion function.
func Convert_v1beta2_ExternalEntityReference_To_controlplane_ExternalEntityReference(in *ExternalEntityReference, out *controlplane.ExternalEntityReference, s conversion.Scope) error {
	return autoConvert_v1beta2_ExternalEntityReference_To_controlplane_ExternalEntityReference(in, out, s)
}

func autoConvert_controlplane_ExternalEntityReference_To_v1beta2_ExternalEntityReference(in *controlplane.ExternalEntityReference, out *ExternalEntityReference, s conversion.Scope) error {
	out.Name = in.Name
	out.Namespace = in.Namespace
	return nil
}

// Convert_controlplane_ExternalEntityReference_To_v1beta2_ExternalEntityReference is an autogenerated conversion function.
func Convert_controlplane_ExternalEntityReference_To_v1beta2_ExternalEntityReference(in *controlplane.ExternalEntityReference, out *ExternalEntityReference, s conversion.Scope) error {
	return autoConvert_controlplane_ExternalEntityReference_To_v1beta2_ExternalEntityReference(in, out, s)
}

func autoConvert_v1beta2_GroupAssociation_To_controlplane_GroupAssociation(in *GroupAssociation, out *controlplane.GroupAssociation, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.AssociatedGroups = *(*[]controlplane.GroupReference)(unsafe.Pointer(&in.AssociatedGroups))
	return nil
}

// Convert_v1beta2_GroupAssociation_To_controlplane_GroupAssociation is an autogenerated conversion function.
func Convert_v1beta2_GroupAssociation_To_controlplane_GroupAssociation(in *GroupAssociation, out *controlplane.GroupAssociation, s conversion.Scope) error {
	return autoConvert_v1beta2_GroupAssociation_To_controlplane_GroupAssociation(in, out, s)
}

func autoConvert_controlplane_GroupAssociation_To_v1beta2_GroupAssociation(in *controlplane.GroupAssociation, out *GroupAssociation, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.AssociatedGroups = *(*[]GroupReference)(unsafe.Pointer(&in.AssociatedGroups))
	return nil
}

// Convert_controlplane_GroupAssociation_To_v1beta2_GroupAssociation is an autogenerated conversion function.
func Convert_controlplane_GroupAssociation_To_v1beta2_GroupAssociation(in *controlplane.GroupAssociation, out *GroupAssociation, s conversion.Scope) error {
	return autoConvert_controlplane_GroupAssociation_To_v1beta2_GroupAssociation(in, out, s)
}

func autoConvert_v1beta2_GroupMember_To_controlplane_GroupMember(in *GroupMember, out *controlplane.GroupMember, s conversion.Scope) error {
	out.Pod = (*controlplane.PodReference)(unsafe.Pointer(in.Pod))
	out.ExternalEntity = (*controlplane.ExternalEntityReference)(unsafe.Pointer(in.ExternalEntity))
	out.IPs = *(*[]controlplane.IPAddress)(unsafe.Pointer(&in.IPs))
	out.Ports = *(*[]controlplane.NamedPort)(unsafe.Pointer(&in.Ports))
	return nil
}

// Convert_v1beta2_GroupMember_To_controlplane_GroupMember is an autogenerated conversion function.
func Convert_v1beta2_GroupMember_To_controlplane_GroupMember(in *GroupMember, out *controlplane.GroupMember, s conversion.Scope) error {
	return autoConvert_v1beta2_GroupMember_To_controlplane_GroupMember(in, out, s)
}

func autoConvert_controlplane_GroupMember_To_v1beta2_GroupMember(in *controlplane.GroupMember, out *GroupMember, s conversion.Scope) error {
	out.Pod = (*PodReference)(unsafe.Pointer(in.Pod))
	out.ExternalEntity = (*ExternalEntityReference)(unsafe.Pointer(in.ExternalEntity))
	out.IPs = *(*[]IPAddress)(unsafe.Pointer(&in.IPs))
	out.Ports = *(*[]NamedPort)(unsafe.Pointer(&in.Ports))
	return nil
}

// Convert_controlplane_GroupMember_To_v1beta2_GroupMember is an autogenerated conversion function.
func Convert_controlplane_GroupMember_To_v1beta2_GroupMember(in *controlplane.GroupMember, out *GroupMember, s conversion.Scope) error {
	return autoConvert_controlplane_GroupMember_To_v1beta2_GroupMember(in, out, s)
}

func autoConvert_v1beta2_GroupReference_To_controlplane_GroupReference(in *GroupReference, out *controlplane.GroupReference, s conversion.Scope) error {
	out.Namespace = in.Namespace
	out.Name = in.Name
	out.UID = types.UID(in.UID)
	return nil
}

// Convert_v1beta2_GroupReference_To_controlplane_GroupReference is an autogenerated conversion function.
func Convert_v1beta2_GroupReference_To_controlplane_GroupReference(in *GroupReference, out *controlplane.GroupReference, s conversion.Scope) error {
	return autoConvert_v1beta2_GroupReference_To_controlplane_GroupReference(in, out, s)
}

func autoConvert_controlplane_GroupReference_To_v1beta2_GroupReference(in *controlplane.GroupReference, out *GroupReference, s conversion.Scope) error {
	out.Namespace = in.Namespace
	out.Name = in.Name
	out.UID = types.UID(in.UID)
	return nil
}

// Convert_controlplane_GroupReference_To_v1beta2_GroupReference is an autogenerated conversion function.
func Convert_controlplane_GroupReference_To_v1beta2_GroupReference(in *controlplane.GroupReference, out *GroupReference, s conversion.Scope) error {
	return autoConvert_controlplane_GroupReference_To_v1beta2_GroupReference(in, out, s)
}

func autoConvert_v1beta2_IPBlock_To_controlplane_IPBlock(in *IPBlock, out *controlplane.IPBlock, s conversion.Scope) error {
	if err := Convert_v1beta2_IPNet_To_controlplane_IPNet(&in.CIDR, &out.CIDR, s); err != nil {
		return err
	}
	out.Except = *(*[]controlplane.IPNet)(unsafe.Pointer(&in.Except))
	return nil
}

// Convert_v1beta2_IPBlock_To_controlplane_IPBlock is an autogenerated conversion function.
func Convert_v1beta2_IPBlock_To_controlplane_IPBlock(in *IPBlock, out *controlplane.IPBlock, s conversion.Scope) error {
	return autoConvert_v1beta2_IPBlock_To_controlplane_IPBlock(in, out, s)
}

func autoConvert_controlplane_IPBlock_To_v1beta2_IPBlock(in *controlplane.IPBlock, out *IPBlock, s conversion.Scope) error {
	if err := Convert_controlplane_IPNet_To_v1beta2_IPNet(&in.CIDR, &out.CIDR, s); err != nil {
		return err
	}
	out.Except = *(*[]IPNet)(unsafe.Pointer(&in.Except))
	return nil
}

// Convert_controlplane_IPBlock_To_v1beta2_IPBlock is an autogenerated conversion function.
func Convert_controlplane_IPBlock_To_v1beta2_IPBlock(in *controlplane.IPBlock, out *IPBlock, s conversion.Scope) error {
	return autoConvert_controlplane_IPBlock_To_v1beta2_IPBlock(in, out, s)
}

func autoConvert_v1beta2_IPNet_To_controlplane_IPNet(in *IPNet, out *controlplane.IPNet, s conversion.Scope) error {
	out.IP = *(*controlplane.IPAddress)(unsafe.Pointer(&in.IP))
	out.PrefixLength = in.PrefixLength
	return nil
}

// Convert_v1beta2_IPNet_To_controlplane_IPNet is an autogenerated conversion function.
func Convert_v1beta2_IPNet_To_controlplane_IPNet(in *IPNet, out *controlplane.IPNet, s conversion.Scope) error {
	return autoConvert_v1beta2_IPNet_To_controlplane_IPNet(in, out, s)
}

func autoConvert_controlplane_IPNet_To_v1beta2_IPNet(in *controlplane.IPNet, out *IPNet, s conversion.Scope) error {
	out.IP = *(*IPAddress)(unsafe.Pointer(&in.IP))
	out.PrefixLength = in.PrefixLength
	return nil
}

// Convert_controlplane_IPNet_To_v1beta2_IPNet is an autogenerated conversion function.
func Convert_controlplane_IPNet_To_v1beta2_IPNet(in *controlplane.IPNet, out *IPNet, s conversion.Scope) error {
	return autoConvert_controlplane_IPNet_To_v1beta2_IPNet(in, out, s)
}

func autoConvert_v1beta2_NamedPort_To_controlplane_NamedPort(in *NamedPort, out *controlplane.NamedPort, s conversion.Scope) error {
	out.Port = in.Port
	out.Name = in.Name
	out.Protocol = controlplane.Protocol(in.Protocol)
	return nil
}

// Convert_v1beta2_NamedPort_To_controlplane_NamedPort is an autogenerated conversion function.
func Convert_v1beta2_NamedPort_To_controlplane_NamedPort(in *NamedPort, out *controlplane.NamedPort, s conversion.Scope) error {
	return autoConvert_v1beta2_NamedPort_To_controlplane_NamedPort(in, out, s)
}

func autoConvert_controlplane_NamedPort_To_v1beta2_NamedPort(in *controlplane.NamedPort, out *NamedPort, s conversion.Scope) error {
	out.Port = in.Port
	out.Name = in.Name
	out.Protocol = Protocol(in.Protocol)
	return nil
}

// Convert_controlplane_NamedPort_To_v1beta2_NamedPort is an autogenerated conversion function.
func Convert_controlplane_NamedPort_To_v1beta2_NamedPort(in *controlplane.NamedPort, out *NamedPort, s conversion.Scope) error {
	return autoConvert_controlplane_NamedPort_To_v1beta2_NamedPort(in, out, s)
}

func autoConvert_v1beta2_NetworkPolicy_To_controlplane_NetworkPolicy(in *NetworkPolicy, out *controlplane.NetworkPolicy, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.Rules = *(*[]controlplane.NetworkPolicyRule)(unsafe.Pointer(&in.Rules))
	out.AppliedToGroups = *(*[]string)(unsafe.Pointer(&in.AppliedToGroups))
	out.Priority = (*float64)(unsafe.Pointer(in.Priority))
	out.TierPriority = (*int32)(unsafe.Pointer(in.TierPriority))
	out.SourceRef = (*controlplane.NetworkPolicyReference)(unsafe.Pointer(in.SourceRef))
	return nil
}

// Convert_v1beta2_NetworkPolicy_To_controlplane_NetworkPolicy is an autogenerated conversion function.
func Convert_v1beta2_NetworkPolicy_To_controlplane_NetworkPolicy(in *NetworkPolicy, out *controlplane.NetworkPolicy, s conversion.Scope) error {
	return autoConvert_v1beta2_NetworkPolicy_To_controlplane_NetworkPolicy(in, out, s)
}

func autoConvert_controlplane_NetworkPolicy_To_v1beta2_NetworkPolicy(in *controlplane.NetworkPolicy, out *NetworkPolicy, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.Rules = *(*[]NetworkPolicyRule)(unsafe.Pointer(&in.Rules))
	out.AppliedToGroups = *(*[]string)(unsafe.Pointer(&in.AppliedToGroups))
	out.Priority = (*float64)(unsafe.Pointer(in.Priority))
	out.TierPriority = (*int32)(unsafe.Pointer(in.TierPriority))
	out.SourceRef = (*NetworkPolicyReference)(unsafe.Pointer(in.SourceRef))
	return nil
}

// Convert_controlplane_NetworkPolicy_To_v1beta2_NetworkPolicy is an autogenerated conversion function.
func Convert_controlplane_NetworkPolicy_To_v1beta2_NetworkPolicy(in *controlplane.NetworkPolicy, out *NetworkPolicy, s conversion.Scope) error {
	return autoConvert_controlplane_NetworkPolicy_To_v1beta2_NetworkPolicy(in, out, s)
}

func autoConvert_v1beta2_NetworkPolicyList_To_controlplane_NetworkPolicyList(in *NetworkPolicyList, out *controlplane.NetworkPolicyList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]controlplane.NetworkPolicy)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1beta2_NetworkPolicyList_To_controlplane_NetworkPolicyList is an autogenerated conversion function.
func Convert_v1beta2_NetworkPolicyList_To_controlplane_NetworkPolicyList(in *NetworkPolicyList, out *controlplane.NetworkPolicyList, s conversion.Scope) error {
	return autoConvert_v1beta2_NetworkPolicyList_To_controlplane_NetworkPolicyList(in, out, s)
}

func autoConvert_controlplane_NetworkPolicyList_To_v1beta2_NetworkPolicyList(in *controlplane.NetworkPolicyList, out *NetworkPolicyList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]NetworkPolicy)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_controlplane_NetworkPolicyList_To_v1beta2_NetworkPolicyList is an autogenerated conversion function.
func Convert_controlplane_NetworkPolicyList_To_v1beta2_NetworkPolicyList(in *controlplane.NetworkPolicyList, out *NetworkPolicyList, s conversion.Scope) error {
	return autoConvert_controlplane_NetworkPolicyList_To_v1beta2_NetworkPolicyList(in, out, s)
}

func autoConvert_v1beta2_NetworkPolicyNodeStatus_To_controlplane_NetworkPolicyNodeStatus(in *NetworkPolicyNodeStatus, out *controlplane.NetworkPolicyNodeStatus, s conversion.Scope) error {
	out.NodeName = in.NodeName
	out.Generation = in.Generation
	return nil
}

// Convert_v1beta2_NetworkPolicyNodeStatus_To_controlplane_NetworkPolicyNodeStatus is an autogenerated conversion function.
func Convert_v1beta2_NetworkPolicyNodeStatus_To_controlplane_NetworkPolicyNodeStatus(in *NetworkPolicyNodeStatus, out *controlplane.NetworkPolicyNodeStatus, s conversion.Scope) error {
	return autoConvert_v1beta2_NetworkPolicyNodeStatus_To_controlplane_NetworkPolicyNodeStatus(in, out, s)
}

func autoConvert_controlplane_NetworkPolicyNodeStatus_To_v1beta2_NetworkPolicyNodeStatus(in *controlplane.NetworkPolicyNodeStatus, out *NetworkPolicyNodeStatus, s conversion.Scope) error {
	out.NodeName = in.NodeName
	out.Generation = in.Generation
	return nil
}

// Convert_controlplane_NetworkPolicyNodeStatus_To_v1beta2_NetworkPolicyNodeStatus is an autogenerated conversion function.
func Convert_controlplane_NetworkPolicyNodeStatus_To_v1beta2_NetworkPolicyNodeStatus(in *controlplane.NetworkPolicyNodeStatus, out *NetworkPolicyNodeStatus, s conversion.Scope) error {
	return autoConvert_controlplane_NetworkPolicyNodeStatus_To_v1beta2_NetworkPolicyNodeStatus(in, out, s)
}

func autoConvert_v1beta2_NetworkPolicyPeer_To_controlplane_NetworkPolicyPeer(in *NetworkPolicyPeer, out *controlplane.NetworkPolicyPeer, s conversion.Scope) error {
	out.AddressGroups = *(*[]string)(unsafe.Pointer(&in.AddressGroups))
	out.IPBlocks = *(*[]controlplane.IPBlock)(unsafe.Pointer(&in.IPBlocks))
	return nil
}

// Convert_v1beta2_NetworkPolicyPeer_To_controlplane_NetworkPolicyPeer is an autogenerated conversion function.
func Convert_v1beta2_NetworkPolicyPeer_To_controlplane_NetworkPolicyPeer(in *NetworkPolicyPeer, out *controlplane.NetworkPolicyPeer, s conversion.Scope) error {
	return autoConvert_v1beta2_NetworkPolicyPeer_To_controlplane_NetworkPolicyPeer(in, out, s)
}

func autoConvert_controlplane_NetworkPolicyPeer_To_v1beta2_NetworkPolicyPeer(in *controlplane.NetworkPolicyPeer, out *NetworkPolicyPeer, s conversion.Scope) error {
	out.AddressGroups = *(*[]string)(unsafe.Pointer(&in.AddressGroups))
	out.IPBlocks = *(*[]IPBlock)(unsafe.Pointer(&in.IPBlocks))
	return nil
}

// Convert_controlplane_NetworkPolicyPeer_To_v1beta2_NetworkPolicyPeer is an autogenerated conversion function.
func Convert_controlplane_NetworkPolicyPeer_To_v1beta2_NetworkPolicyPeer(in *controlplane.NetworkPolicyPeer, out *NetworkPolicyPeer, s conversion.Scope) error {
	return autoConvert_controlplane_NetworkPolicyPeer_To_v1beta2_NetworkPolicyPeer(in, out, s)
}

func autoConvert_v1beta2_NetworkPolicyReference_To_controlplane_NetworkPolicyReference(in *NetworkPolicyReference, out *controlplane.NetworkPolicyReference, s conversion.Scope) error {
	out.Type = controlplane.NetworkPolicyType(in.Type)
	out.Namespace = in.Namespace
	out.Name = in.Name
	out.UID = types.UID(in.UID)
	return nil
}

// Convert_v1beta2_NetworkPolicyReference_To_controlplane_NetworkPolicyReference is an autogenerated conversion function.
func Convert_v1beta2_NetworkPolicyReference_To_controlplane_NetworkPolicyReference(in *NetworkPolicyReference, out *controlplane.NetworkPolicyReference, s conversion.Scope) error {
	return autoConvert_v1beta2_NetworkPolicyReference_To_controlplane_NetworkPolicyReference(in, out, s)
}

func autoConvert_controlplane_NetworkPolicyReference_To_v1beta2_NetworkPolicyReference(in *controlplane.NetworkPolicyReference, out *NetworkPolicyReference, s conversion.Scope) error {
	out.Type = NetworkPolicyType(in.Type)
	out.Namespace = in.Namespace
	out.Name = in.Name
	out.UID = types.UID(in.UID)
	return nil
}

// Convert_controlplane_NetworkPolicyReference_To_v1beta2_NetworkPolicyReference is an autogenerated conversion function.
func Convert_controlplane_NetworkPolicyReference_To_v1beta2_NetworkPolicyReference(in *controlplane.NetworkPolicyReference, out *NetworkPolicyReference, s conversion.Scope) error {
	return autoConvert_controlplane_NetworkPolicyReference_To_v1beta2_NetworkPolicyReference(in, out, s)
}

func autoConvert_v1beta2_NetworkPolicyRule_To_controlplane_NetworkPolicyRule(in *NetworkPolicyRule, out *controlplane.NetworkPolicyRule, s conversion.Scope) error {
	out.Direction = controlplane.Direction(in.Direction)
	if err := Convert_v1beta2_NetworkPolicyPeer_To_controlplane_NetworkPolicyPeer(&in.From, &out.From, s); err != nil {
		return err
	}
	if err := Convert_v1beta2_NetworkPolicyPeer_To_controlplane_NetworkPolicyPeer(&in.To, &out.To, s); err != nil {
		return err
	}
	out.Services = *(*[]controlplane.Service)(unsafe.Pointer(&in.Services))
	out.Priority = in.Priority
	out.Action = (*v1alpha1.RuleAction)(unsafe.Pointer(in.Action))
	out.EnableLogging = in.EnableLogging
	out.AppliedToGroups = *(*[]string)(unsafe.Pointer(&in.AppliedToGroups))
	return nil
}

// Convert_v1beta2_NetworkPolicyRule_To_controlplane_NetworkPolicyRule is an autogenerated conversion function.
func Convert_v1beta2_NetworkPolicyRule_To_controlplane_NetworkPolicyRule(in *NetworkPolicyRule, out *controlplane.NetworkPolicyRule, s conversion.Scope) error {
	return autoConvert_v1beta2_NetworkPolicyRule_To_controlplane_NetworkPolicyRule(in, out, s)
}

func autoConvert_controlplane_NetworkPolicyRule_To_v1beta2_NetworkPolicyRule(in *controlplane.NetworkPolicyRule, out *NetworkPolicyRule, s conversion.Scope) error {
	out.Direction = Direction(in.Direction)
	if err := Convert_controlplane_NetworkPolicyPeer_To_v1beta2_NetworkPolicyPeer(&in.From, &out.From, s); err != nil {
		return err
	}
	if err := Convert_controlplane_NetworkPolicyPeer_To_v1beta2_NetworkPolicyPeer(&in.To, &out.To, s); err != nil {
		return err
	}
	out.Services = *(*[]Service)(unsafe.Pointer(&in.Services))
	out.Priority = in.Priority
	out.Action = (*v1alpha1.RuleAction)(unsafe.Pointer(in.Action))
	out.EnableLogging = in.EnableLogging
	out.AppliedToGroups = *(*[]string)(unsafe.Pointer(&in.AppliedToGroups))
	return nil
}

// Convert_controlplane_NetworkPolicyRule_To_v1beta2_NetworkPolicyRule is an autogenerated conversion function.
func Convert_controlplane_NetworkPolicyRule_To_v1beta2_NetworkPolicyRule(in *controlplane.NetworkPolicyRule, out *NetworkPolicyRule, s conversion.Scope) error {
	return autoConvert_controlplane_NetworkPolicyRule_To_v1beta2_NetworkPolicyRule(in, out, s)
}

func autoConvert_v1beta2_NetworkPolicyStats_To_controlplane_NetworkPolicyStats(in *NetworkPolicyStats, out *controlplane.NetworkPolicyStats, s conversion.Scope) error {
	if err := Convert_v1beta2_NetworkPolicyReference_To_controlplane_NetworkPolicyReference(&in.NetworkPolicy, &out.NetworkPolicy, s); err != nil {
		return err
	}
	out.TrafficStats = in.TrafficStats
	return nil
}

// Convert_v1beta2_NetworkPolicyStats_To_controlplane_NetworkPolicyStats is an autogenerated conversion function.
func Convert_v1beta2_NetworkPolicyStats_To_controlplane_NetworkPolicyStats(in *NetworkPolicyStats, out *controlplane.NetworkPolicyStats, s conversion.Scope) error {
	return autoConvert_v1beta2_NetworkPolicyStats_To_controlplane_NetworkPolicyStats(in, out, s)
}

func autoConvert_controlplane_NetworkPolicyStats_To_v1beta2_NetworkPolicyStats(in *controlplane.NetworkPolicyStats, out *NetworkPolicyStats, s conversion.Scope) error {
	if err := Convert_controlplane_NetworkPolicyReference_To_v1beta2_NetworkPolicyReference(&in.NetworkPolicy, &out.NetworkPolicy, s); err != nil {
		return err
	}
	out.TrafficStats = in.TrafficStats
	return nil
}

// Convert_controlplane_NetworkPolicyStats_To_v1beta2_NetworkPolicyStats is an autogenerated conversion function.
func Convert_controlplane_NetworkPolicyStats_To_v1beta2_NetworkPolicyStats(in *controlplane.NetworkPolicyStats, out *NetworkPolicyStats, s conversion.Scope) error {
	return autoConvert_controlplane_NetworkPolicyStats_To_v1beta2_NetworkPolicyStats(in, out, s)
}

func autoConvert_v1beta2_NetworkPolicyStatus_To_controlplane_NetworkPolicyStatus(in *NetworkPolicyStatus, out *controlplane.NetworkPolicyStatus, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.Nodes = *(*[]controlplane.NetworkPolicyNodeStatus)(unsafe.Pointer(&in.Nodes))
	return nil
}

// Convert_v1beta2_NetworkPolicyStatus_To_controlplane_NetworkPolicyStatus is an autogenerated conversion function.
func Convert_v1beta2_NetworkPolicyStatus_To_controlplane_NetworkPolicyStatus(in *NetworkPolicyStatus, out *controlplane.NetworkPolicyStatus, s conversion.Scope) error {
	return autoConvert_v1beta2_NetworkPolicyStatus_To_controlplane_NetworkPolicyStatus(in, out, s)
}

func autoConvert_controlplane_NetworkPolicyStatus_To_v1beta2_NetworkPolicyStatus(in *controlplane.NetworkPolicyStatus, out *NetworkPolicyStatus, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.Nodes = *(*[]NetworkPolicyNodeStatus)(unsafe.Pointer(&in.Nodes))
	return nil
}

// Convert_controlplane_NetworkPolicyStatus_To_v1beta2_NetworkPolicyStatus is an autogenerated conversion function.
func Convert_controlplane_NetworkPolicyStatus_To_v1beta2_NetworkPolicyStatus(in *controlplane.NetworkPolicyStatus, out *NetworkPolicyStatus, s conversion.Scope) error {
	return autoConvert_controlplane_NetworkPolicyStatus_To_v1beta2_NetworkPolicyStatus(in, out, s)
}

func autoConvert_v1beta2_NodeStatsSummary_To_controlplane_NodeStatsSummary(in *NodeStatsSummary, out *controlplane.NodeStatsSummary, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.NetworkPolicies = *(*[]controlplane.NetworkPolicyStats)(unsafe.Pointer(&in.NetworkPolicies))
	out.AntreaClusterNetworkPolicies = *(*[]controlplane.NetworkPolicyStats)(unsafe.Pointer(&in.AntreaClusterNetworkPolicies))
	out.AntreaNetworkPolicies = *(*[]controlplane.NetworkPolicyStats)(unsafe.Pointer(&in.AntreaNetworkPolicies))
	return nil
}

// Convert_v1beta2_NodeStatsSummary_To_controlplane_NodeStatsSummary is an autogenerated conversion function.
func Convert_v1beta2_NodeStatsSummary_To_controlplane_NodeStatsSummary(in *NodeStatsSummary, out *controlplane.NodeStatsSummary, s conversion.Scope) error {
	return autoConvert_v1beta2_NodeStatsSummary_To_controlplane_NodeStatsSummary(in, out, s)
}

func autoConvert_controlplane_NodeStatsSummary_To_v1beta2_NodeStatsSummary(in *controlplane.NodeStatsSummary, out *NodeStatsSummary, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	out.NetworkPolicies = *(*[]NetworkPolicyStats)(unsafe.Pointer(&in.NetworkPolicies))
	out.AntreaClusterNetworkPolicies = *(*[]NetworkPolicyStats)(unsafe.Pointer(&in.AntreaClusterNetworkPolicies))
	out.AntreaNetworkPolicies = *(*[]NetworkPolicyStats)(unsafe.Pointer(&in.AntreaNetworkPolicies))
	return nil
}

// Convert_controlplane_NodeStatsSummary_To_v1beta2_NodeStatsSummary is an autogenerated conversion function.
func Convert_controlplane_NodeStatsSummary_To_v1beta2_NodeStatsSummary(in *controlplane.NodeStatsSummary, out *NodeStatsSummary, s conversion.Scope) error {
	return autoConvert_controlplane_NodeStatsSummary_To_v1beta2_NodeStatsSummary(in, out, s)
}

func autoConvert_v1beta2_PodReference_To_controlplane_PodReference(in *PodReference, out *controlplane.PodReference, s conversion.Scope) error {
	out.Name = in.Name
	out.Namespace = in.Namespace
	return nil
}

// Convert_v1beta2_PodReference_To_controlplane_PodReference is an autogenerated conversion function.
func Convert_v1beta2_PodReference_To_controlplane_PodReference(in *PodReference, out *controlplane.PodReference, s conversion.Scope) error {
	return autoConvert_v1beta2_PodReference_To_controlplane_PodReference(in, out, s)
}

func autoConvert_controlplane_PodReference_To_v1beta2_PodReference(in *controlplane.PodReference, out *PodReference, s conversion.Scope) error {
	out.Name = in.Name
	out.Namespace = in.Namespace
	return nil
}

// Convert_controlplane_PodReference_To_v1beta2_PodReference is an autogenerated conversion function.
func Convert_controlplane_PodReference_To_v1beta2_PodReference(in *controlplane.PodReference, out *PodReference, s conversion.Scope) error {
	return autoConvert_controlplane_PodReference_To_v1beta2_PodReference(in, out, s)
}

func autoConvert_v1beta2_Service_To_controlplane_Service(in *Service, out *controlplane.Service, s conversion.Scope) error {
	out.Protocol = (*controlplane.Protocol)(unsafe.Pointer(in.Protocol))
	out.Port = (*intstr.IntOrString)(unsafe.Pointer(in.Port))
	out.EndPort = (*int32)(unsafe.Pointer(in.EndPort))
	return nil
}

// Convert_v1beta2_Service_To_controlplane_Service is an autogenerated conversion function.
func Convert_v1beta2_Service_To_controlplane_Service(in *Service, out *controlplane.Service, s conversion.Scope) error {
	return autoConvert_v1beta2_Service_To_controlplane_Service(in, out, s)
}

func autoConvert_controlplane_Service_To_v1beta2_Service(in *controlplane.Service, out *Service, s conversion.Scope) error {
	out.Protocol = (*Protocol)(unsafe.Pointer(in.Protocol))
	out.Port = (*intstr.IntOrString)(unsafe.Pointer(in.Port))
	out.EndPort = (*int32)(unsafe.Pointer(in.EndPort))
	return nil
}

// Convert_controlplane_Service_To_v1beta2_Service is an autogenerated conversion function.
func Convert_controlplane_Service_To_v1beta2_Service(in *controlplane.Service, out *Service, s conversion.Scope) error {
	return autoConvert_controlplane_Service_To_v1beta2_Service(in, out, s)
}

func autoConvert_v1beta2_ServiceReference_To_controlplane_ServiceReference(in *ServiceReference, out *controlplane.ServiceReference, s conversion.Scope) error {
	out.Name = in.Name
	out.Namespace = in.Namespace
	return nil
}

// Convert_v1beta2_ServiceReference_To_controlplane_ServiceReference is an autogenerated conversion function.
func Convert_v1beta2_ServiceReference_To_controlplane_ServiceReference(in *ServiceReference, out *controlplane.ServiceReference, s conversion.Scope) error {
	return autoConvert_v1beta2_ServiceReference_To_controlplane_ServiceReference(in, out, s)
}

func autoConvert_controlplane_ServiceReference_To_v1beta2_ServiceReference(in *controlplane.ServiceReference, out *ServiceReference, s conversion.Scope) error {
	out.Name = in.Name
	out.Namespace = in.Namespace
	return nil
}

// Convert_controlplane_ServiceReference_To_v1beta2_ServiceReference is an autogenerated conversion function.
func Convert_controlplane_ServiceReference_To_v1beta2_ServiceReference(in *controlplane.ServiceReference, out *ServiceReference, s conversion.Scope) error {
	return autoConvert_controlplane_ServiceReference_To_v1beta2_ServiceReference(in, out, s)
}
