// Copyright 2020 Antrea Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"context"
	"time"

	v1beta1 "github.com/vmware-tanzu/antrea/pkg/apis/clusterinformation/v1beta1"
	scheme "github.com/vmware-tanzu/antrea/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// AntreaAgentInfosGetter has a method to return a AntreaAgentInfoInterface.
// A group's client should implement this interface.
type AntreaAgentInfosGetter interface {
	AntreaAgentInfos() AntreaAgentInfoInterface
}

// AntreaAgentInfoInterface has methods to work with AntreaAgentInfo resources.
type AntreaAgentInfoInterface interface {
	Create(ctx context.Context, antreaAgentInfo *v1beta1.AntreaAgentInfo, opts v1.CreateOptions) (*v1beta1.AntreaAgentInfo, error)
	Update(ctx context.Context, antreaAgentInfo *v1beta1.AntreaAgentInfo, opts v1.UpdateOptions) (*v1beta1.AntreaAgentInfo, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta1.AntreaAgentInfo, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta1.AntreaAgentInfoList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.AntreaAgentInfo, err error)
	AntreaAgentInfoExpansion
}

// antreaAgentInfos implements AntreaAgentInfoInterface
type antreaAgentInfos struct {
	client rest.Interface
}

// newAntreaAgentInfos returns a AntreaAgentInfos
func newAntreaAgentInfos(c *ClusterinformationV1beta1Client) *antreaAgentInfos {
	return &antreaAgentInfos{
		client: c.RESTClient(),
	}
}

// Get takes name of the antreaAgentInfo, and returns the corresponding antreaAgentInfo object, and an error if there is any.
func (c *antreaAgentInfos) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.AntreaAgentInfo, err error) {
	result = &v1beta1.AntreaAgentInfo{}
	err = c.client.Get().
		Resource("antreaagentinfos").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of AntreaAgentInfos that match those selectors.
func (c *antreaAgentInfos) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.AntreaAgentInfoList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta1.AntreaAgentInfoList{}
	err = c.client.Get().
		Resource("antreaagentinfos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested antreaAgentInfos.
func (c *antreaAgentInfos) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("antreaagentinfos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a antreaAgentInfo and creates it.  Returns the server's representation of the antreaAgentInfo, and an error, if there is any.
func (c *antreaAgentInfos) Create(ctx context.Context, antreaAgentInfo *v1beta1.AntreaAgentInfo, opts v1.CreateOptions) (result *v1beta1.AntreaAgentInfo, err error) {
	result = &v1beta1.AntreaAgentInfo{}
	err = c.client.Post().
		Resource("antreaagentinfos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(antreaAgentInfo).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a antreaAgentInfo and updates it. Returns the server's representation of the antreaAgentInfo, and an error, if there is any.
func (c *antreaAgentInfos) Update(ctx context.Context, antreaAgentInfo *v1beta1.AntreaAgentInfo, opts v1.UpdateOptions) (result *v1beta1.AntreaAgentInfo, err error) {
	result = &v1beta1.AntreaAgentInfo{}
	err = c.client.Put().
		Resource("antreaagentinfos").
		Name(antreaAgentInfo.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(antreaAgentInfo).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the antreaAgentInfo and deletes it. Returns an error if one occurs.
func (c *antreaAgentInfos) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("antreaagentinfos").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *antreaAgentInfos) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("antreaagentinfos").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched antreaAgentInfo.
func (c *antreaAgentInfos) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.AntreaAgentInfo, err error) {
	result = &v1beta1.AntreaAgentInfo{}
	err = c.client.Patch(pt).
		Resource("antreaagentinfos").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
