// Copyright 2020 Antrea Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/vmware-tanzu/antrea/pkg/apis/clusterinformation/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeAntreaControllerInfos implements AntreaControllerInfoInterface
type FakeAntreaControllerInfos struct {
	Fake *FakeClusterinformationV1beta1
}

var antreacontrollerinfosResource = schema.GroupVersionResource{Group: "clusterinformation.antrea.tanzu.vmware.com", Version: "v1beta1", Resource: "antreacontrollerinfos"}

var antreacontrollerinfosKind = schema.GroupVersionKind{Group: "clusterinformation.antrea.tanzu.vmware.com", Version: "v1beta1", Kind: "AntreaControllerInfo"}

// Get takes name of the antreaControllerInfo, and returns the corresponding antreaControllerInfo object, and an error if there is any.
func (c *FakeAntreaControllerInfos) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.AntreaControllerInfo, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(antreacontrollerinfosResource, name), &v1beta1.AntreaControllerInfo{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.AntreaControllerInfo), err
}

// List takes label and field selectors, and returns the list of AntreaControllerInfos that match those selectors.
func (c *FakeAntreaControllerInfos) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.AntreaControllerInfoList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(antreacontrollerinfosResource, antreacontrollerinfosKind, opts), &v1beta1.AntreaControllerInfoList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.AntreaControllerInfoList{ListMeta: obj.(*v1beta1.AntreaControllerInfoList).ListMeta}
	for _, item := range obj.(*v1beta1.AntreaControllerInfoList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested antreaControllerInfos.
func (c *FakeAntreaControllerInfos) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(antreacontrollerinfosResource, opts))
}

// Create takes the representation of a antreaControllerInfo and creates it.  Returns the server's representation of the antreaControllerInfo, and an error, if there is any.
func (c *FakeAntreaControllerInfos) Create(ctx context.Context, antreaControllerInfo *v1beta1.AntreaControllerInfo, opts v1.CreateOptions) (result *v1beta1.AntreaControllerInfo, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(antreacontrollerinfosResource, antreaControllerInfo), &v1beta1.AntreaControllerInfo{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.AntreaControllerInfo), err
}

// Update takes the representation of a antreaControllerInfo and updates it. Returns the server's representation of the antreaControllerInfo, and an error, if there is any.
func (c *FakeAntreaControllerInfos) Update(ctx context.Context, antreaControllerInfo *v1beta1.AntreaControllerInfo, opts v1.UpdateOptions) (result *v1beta1.AntreaControllerInfo, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(antreacontrollerinfosResource, antreaControllerInfo), &v1beta1.AntreaControllerInfo{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.AntreaControllerInfo), err
}

// Delete takes name of the antreaControllerInfo and deletes it. Returns an error if one occurs.
func (c *FakeAntreaControllerInfos) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(antreacontrollerinfosResource, name), &v1beta1.AntreaControllerInfo{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeAntreaControllerInfos) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(antreacontrollerinfosResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.AntreaControllerInfoList{})
	return err
}

// Patch applies the patch and returns the patched antreaControllerInfo.
func (c *FakeAntreaControllerInfos) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.AntreaControllerInfo, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(antreacontrollerinfosResource, name, pt, data, subresources...), &v1beta1.AntreaControllerInfo{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.AntreaControllerInfo), err
}
