// Copyright 2020 Antrea Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"context"

	v1beta1 "github.com/vmware-tanzu/antrea/pkg/apis/system/v1beta1"
	scheme "github.com/vmware-tanzu/antrea/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	rest "k8s.io/client-go/rest"
)

// SupportBundlesGetter has a method to return a SupportBundleInterface.
// A group's client should implement this interface.
type SupportBundlesGetter interface {
	SupportBundles() SupportBundleInterface
}

// SupportBundleInterface has methods to work with SupportBundle resources.
type SupportBundleInterface interface {
	Create(ctx context.Context, supportBundle *v1beta1.SupportBundle, opts v1.CreateOptions) (*v1beta1.SupportBundle, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta1.SupportBundle, error)
	SupportBundleExpansion
}

// supportBundles implements SupportBundleInterface
type supportBundles struct {
	client rest.Interface
}

// newSupportBundles returns a SupportBundles
func newSupportBundles(c *SystemV1beta1Client) *supportBundles {
	return &supportBundles{
		client: c.RESTClient(),
	}
}

// Get takes name of the supportBundle, and returns the corresponding supportBundle object, and an error if there is any.
func (c *supportBundles) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.SupportBundle, err error) {
	result = &v1beta1.SupportBundle{}
	err = c.client.Get().
		Resource("supportbundles").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// Create takes the representation of a supportBundle and creates it.  Returns the server's representation of the supportBundle, and an error, if there is any.
func (c *supportBundles) Create(ctx context.Context, supportBundle *v1beta1.SupportBundle, opts v1.CreateOptions) (result *v1beta1.SupportBundle, err error) {
	result = &v1beta1.SupportBundle{}
	err = c.client.Post().
		Resource("supportbundles").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(supportBundle).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the supportBundle and deletes it. Returns an error if one occurs.
func (c *supportBundles) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("supportbundles").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}
